
import 'dart:async';
import 'dart:ffi';

import 'package:flutter/cupertino.dart';
import 'package:flutter/services.dart';

class SpectusInAppPurchase {
  static const MethodChannel _channel =
      const MethodChannel('spectus_in_app_purchase');

  static Future<String> get platformVersion async {
    final String version = await _channel.invokeMethod('getPlatformVersion');
    return version;
  }

  static Future<String> startInAppPurchaseWith({String productID}) async
  {
    final String transactionID = await _channel.invokeMethod('startInAppPurchaseWith',
        {
          "productID":productID
        }
    );

    if (transactionID == null) {
      return "NA";
    } else {
      return transactionID;
    }
  }

  static Future<List<Map<String, String>>> getSKUProductListWith({String productID}) async
  {
    final List<Map<String, String>> productsList = await _channel.invokeMethod('getSKUProductListWith',
        {
          "productID":productID
        }
    );
    print("DART => Product List count" + productsList.length.toString());
    print("DART => Product List Details" + productsList[0].toString());
    return productsList;
  }

  static Future<String> startRestorePurchase() async
  {
    final String transactionID = await _channel.invokeMethod('startRestorePurchase');
    if (transactionID == null) {
      return "NA";
    } else {
      return transactionID;
    }
  }
}
